# The LearningOnline Network with CAPA
# caparesponse definition
#
# $Id: caparesponse.pm,v 1.52 2002/04/11 19:48:16 albertel Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#

package Apache::caparesponse;
use strict;
use capa;

BEGIN {
  &Apache::lonxml::register('Apache::caparesponse',('caparesponse','numericalresponse','stringresponse','formularesponse'));
}

sub start_caparesponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval)=@_;
  my $id = &Apache::response::start_response($parstack,$safeeval);
  return '';
}

sub end_caparesponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  my $result = '';
  if ( $target eq 'grade' ) {
    if ( defined $ENV{'form.submitted'}) {
      $safeeval->share_from('capa',['&caparesponse_capa_check_answer']);
      my $response = $ENV{'form.HWVAL'.$Apache::inputtags::response['-1']};
      if ( $response =~ /[^\s]/) {
	my $id = $Apache::inputtags::response['-1'];
	my $previous= &Apache::response::check_for_previous($response,$id,$response);
	if ( $previous ) { 
	  $result = 'PREVIOUSLY_USED';
	} else {
	  $Apache::lonhomework::results{"resource.$Apache::inputtags::part.$id.submission"}=$response;
	  &Apache::lonxml::debug("submitted a $response<br>\n");
	  &Apache::lonxml::debug($$parstack[$#$parstack] . "\n<br>");
	  my $expression="&caparesponse_check('".$response."','".
	    $$parstack[$#$parstack].
	      ';my $tol="'.$Apache::inputtags::params{'tol'}.'"'.
		';my $sig="'.$Apache::inputtags::params{'sig'}.'"'.
		  "');";
	  $result = &Apache::run::run($expression,$safeeval);
	  my ($ad) = split /:/ , $result;
	  $Apache::lonhomework::results{"resource.$Apache::inputtags::part.$id.awarddetail"}=$ad;
	  &Apache::lonxml::debug("$expression");
	  &Apache::lonxml::debug("\n<br>result:$result:$Apache::lonxml::curdepth<br>\n");
	}
      }
    }
  } elsif ($target eq 'web') {
    #$result .= "The correct answer is ".&Apache::run::run("{$$parstack['-1'];".'return $answer}',$safeeval)."\n";
  }
  #Apache::lonxml::debug("\n<br>\nreal end caparesponse<br>\n");
  &Apache::response::end_response;
  return '';
}

sub start_numericalresponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval)=@_;
  my $id = &Apache::response::start_response($parstack,$safeeval);
  my $result;
  if ($target eq 'edit') {
    $result.=&Apache::edit::tag_start($target,$token);
    $result.=&Apache::edit::text_arg('Answer:','answer',$token);
    if ($token->[1] eq 'numericalresponse') {
      $result.=&Apache::edit::text_arg('Unit:','unit',$token,5);
      $result.=&Apache::edit::text_arg('Format:','format',$token,4);
    } elsif ($token->[1] eq 'stringresponse') {
      $result.=&Apache::edit::select_arg('Type:','type',
					 ['cs','ci','mc'],$token);
    } elsif ($token->[1] eq 'formularesponse') {
      $result.=&Apache::edit::text_arg('Sample Points:','samples',$token,40);
    }
    $result.=&Apache::edit::end_row().&Apache::edit::start_spanning_row();
  } elsif ($target eq 'modified') {
    my $constructtag;
    if ($token->[1] eq 'numericalresponse') {
      $constructtag=&Apache::edit::get_new_args($token,$parstack,$safeeval,
						'answer','unit','format');
    } elsif ($token->[1] eq 'stringresponse') {
      $constructtag=&Apache::edit::get_new_args($token,$parstack,$safeeval,
						'answer','type');
    } elsif ($token->[1] eq 'formularesponse') {
      $constructtag=&Apache::edit::get_new_args($token,$parstack,$safeeval,
						'answer','samples');
    }
    if ($constructtag) {
      $result = &Apache::edit::rebuild_tag($token);
      $result.=&Apache::edit::handle_insert();
    }
  } elsif ($target eq 'meta') {
    $result=&Apache::response::meta_package_write('numericalresponse');
  }
  return $result;
}

sub end_numericalresponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  my $result = '';
  if ( $target eq 'grade' ) {
    if ( defined $ENV{'form.submitted'}) {
      &Apache::response::setup_params($$tagstack[-1]);
      $safeeval->share_from('capa',['&caparesponse_capa_check_answer']);
      my $partid = $Apache::inputtags::part;
      my $id = $Apache::inputtags::response['-1'];
      my $response = $ENV{'form.HWVAL'.$id};
      if ( $response =~ /[^\s]/) {
	my %previous = &Apache::response::check_for_previous($response,$partid,$id);
	$Apache::lonhomework::results{"resource.$partid.$id.submission"}=$response;
	&Apache::lonxml::debug("submitted a $response<br>\n");
	&Apache::lonxml::debug($$parstack[$#$parstack] . "\n<br>");
	$response =~ s/\\/\\\\/g;
	$response =~ s/\'/\\\'/g;
	&Apache::lonxml::debug("current $response");
	my $expression="&caparesponse_check_list('".$response."','".
	  $$parstack[$#$parstack];
	foreach my $key (keys(%Apache::inputtags::params)) {
	  $expression.= ';my $'. #'
	    $key.'="'.$Apache::inputtags::params{$key}.'"';
	}
	if ($$tagstack[-1] eq 'formularesponse') {
	  $expression.=';my $type="fml";';
	} elsif ($$tagstack[-1] eq 'numericalresponse') {
	  $expression.=';my $type="float";';
	}
	$expression.="');";
	$result = &Apache::run::run($expression,$safeeval);
	my ($awards) = split /:/ , $result;
	my ($ad) = &Apache::inputtags::finalizeawards(split /,/ , $awards);
	&Apache::response::handle_previous(\%previous,$ad);
	$Apache::lonhomework::results{"resource.$partid.$id.awarddetail"}=$ad;
	&Apache::lonxml::debug("$expression");
	&Apache::lonxml::debug("\n<br>result:$result:$Apache::lonxml::curdepth<br>\n");
	$result='';
      }
    }
  } elsif ($target eq 'web') {
    my $award = $Apache::lonhomework::history{"resource.$Apache::inputtags::part.solved"};
    my $status = $Apache::inputtags::status['-1'];
    if ($award =~ /^correct/ || $status eq "SHOW_ANSWER" ) {
      my (@answers)=&Apache::lonxml::get_param_var('answer',$parstack,
						   $safeeval);
      my (@formats)=&Apache::lonxml::get_param_var('format',$parstack,
						   $safeeval);
      my $unit=&Apache::lonxml::get_param_var('unit',$parstack,$safeeval);

      $result="<br />The computer got ";

      for (my $i=0; $i <= $#answers; $i++) {
	my $answer=$answers[$i];
	my $format;
	if ($#formats > 0) {
	  $format=$formats[$i];
	} else {
	  $format=$formats[0];
	}
	if ((defined($format)) && ($format ne '')) {
	  &Apache::lonxml::debug("formatting with :$format: answer :$answer:");
	  $result.=sprintf('%.'.$format,$answer).',';
	} else {
	  &Apache::lonxml::debug("no format answer :$answer:");
	  $result.="$answer,";
	}
      }
      chop $result;
      $result.=" $unit.<br></br>";
    }
  } elsif ($target eq 'edit') {
    $result.='</td></tr>'.&Apache::edit::end_table;
  } elsif ($target eq 'answer') {

    &Apache::response::setup_params($$tagstack[-1]);
    my (@answers)=&Apache::lonxml::get_param_var('answer',$parstack,$safeeval);
    my (@formats)=&Apache::lonxml::get_param_var('format',$parstack,$safeeval);
    my $unit=&Apache::lonxml::get_param_var('unit',$parstack,$safeeval);
    my $type=&Apache::lonxml::get_param('type',$parstack,$safeeval);

    $result.=&Apache::response::answer_header($$tagstack[-1]);
    for(my $i=0;$i<=$#answers;$i++) {
      my $ans=$answers[$i];
      my $fmt;
      if (@formats) {
	if ($#formats) {
	  $fmt=$formats[$i];
	} else {
	  $fmt=$formats[0];
	}
      }
      my ($high,$low);
      if ($Apache::inputtags::params{'tol'}) {
	($high,$low)=&get_tolrange($ans,$Apache::inputtags::params{'tol'});
      }	
      my ($sighigh,$siglow);
      if ($Apache::inputtags::params{'sig'}) {
	($sighigh,$siglow)=&get_sigrange($Apache::inputtags::params{'sig'});
      }
      if ($fmt) {
	$ans = sprintf('%.'.$fmt,$ans);
	if ($high) {
	  $high = sprintf('%.'.$fmt,$high); $low = sprintf('%.'.$fmt,$low);
	}
      }
      if ($high) { $ans.=' ['.$low.','.$high.'] '; }
      if ($sighigh) { $ans.= "Sig <i>$siglow - $sighigh</i>"; }
      $result.=&Apache::response::answer_part($$tagstack[-1],$ans);
    }
    if ($unit) {
      $result.=&Apache::response::answer_part($$tagstack[-1],"Unit: <b>$unit</b>");
    }
    if ($type || $token->[1] eq 'stringresponse') {
      my $string='Case Insensitive';
      if ($type eq 'mc') {
	$string='Multiple Choice';
      } elsif ($type eq 'cs') {
	$string='Case Sensitive';
      } elsif ($type eq 'ci') {
	$string='Case Insensitive';
      } elsif ($type eq 'fml') {
	$string='Formula';
      }
      $result.=&Apache::response::answer_part($$tagstack[-1],
					      '<b>'.$string.'</b>');
    }
    if ($$tagstack[-1] eq 'formularesponse') {
      my $samples=&Apache::lonxml::get_param('samples',$parstack,$safeeval);
      $result.=&Apache::response::answer_part($$tagstack[-1],$samples);
    }
    $result.=&Apache::response::answer_footer($$tagstack[-1]);
  }
  &Apache::response::end_response;
  return $result;
}

sub get_tolrange {
  my ($ans,$tol)=@_;
  my ($high,$low);
  if ($tol =~ /%$/) {
    chop($tol);
    my $change=$ans*($tol/100.0);
    $high=$ans+$change;
    $low=$ans-$change;
  } else {
    $high=$ans+$tol;
    $low=$ans-$tol;
  }
  return ($high,$low);
}

sub get_sigrange {
  my ($sig)=@_;
  &Apache::lonxml::debug("Got a sig of :$sig:");
  my $sig_lbound;
  my $sig_ubound;
  if ($sig eq '') {
    $sig_lbound = 0; #SIG_LB_DEFAULT
    $sig_ubound =15; #SIG_UB_DEFAULT
  } else {
    ($sig_lbound,$sig_ubound) = split(/,/,$sig);
    if (!$sig_lbound) {
      $sig_lbound = 0; #SIG_LB_DEFAULT
      $sig_ubound =15; #SIG_UB_DEFAULT
    }
    if (!$sig_ubound) { $sig_ubound=$sig_lbound; }
  }
  return ($sig_ubound,$sig_lbound);
}

sub start_stringresponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  my $result;
  if ($target eq 'meta') {
    $result=&Apache::response::meta_package_write('stringresponse');
  } else {
    $result.=&start_numericalresponse(@_);
  }
  return $result;
}

sub end_stringresponse {
  return end_numericalresponse(@_);
}

sub start_formularesponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  my $result;
  if ($target eq 'meta') {
    $result=&Apache::response::meta_package_write('formularesponse');
  } else {
    $result.=&start_numericalresponse(@_);
  }
  return $result;
}

sub end_formularesponse {
  return end_numericalresponse(@_);
}

1;
__END__
 
