# The LearningOnline Network with CAPA 
# tags that create controlled output
#
# $Id: outputtags.pm,v 1.15 2002/01/17 12:23:31 harris41 Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#

package Apache::outputtags; 

use strict;
use Apache::lonnet;
use POSIX qw(strftime);

BEGIN {
  &Apache::lonxml::register('Apache::outputtags',('displayduedate','displaytitle'));
}

sub start_displayduedate {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval)=@_;
  my $result;
  my $status=$Apache::inputtags::status['-1'];
  &Apache::lonxml::debug("got a $status in duedatebox");
  if (($status =~ /CAN.*_ANSWER/) && ($target eq 'web')) {
    my $format = &Apache::lonxml::get_param('format',$parstack,$safeeval);
    if ($format eq '') {
      &Apache::lonxml::debug("using default format");
      $format="%c";
    }
    my $id = $Apache::inputtags::part;
    my $date = &Apache::lonnet::EXT("resource.$id.duedate");
    &Apache::lonxml::debug("duedatebox found $date for $id");
    if ($date) {
       $result ='<table border="on"><tr><td>Due at '.
         POSIX::strftime($format,localtime($date)).
	   '</td></tr></table>';
    } else {
      $result ='<table border="on"><tr><td>No due date set.</td></tr></table>';
    }
  } elsif ( $target eq 'edit' ) {
    $result=&Apache::edit::tag_start($target,$token);
    $result.='</td></tr>';
    $result.=&Apache::edit::end_table();
  }
  return $result;
}

sub end_displayduedate {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval)=@_;
  my @result;
  if ($target eq 'edit') { $result[1]='no'; }
  return @result;
}

sub start_displaytitle {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval)=@_;
  my $result='';
  if ($target eq 'web') {
    $result="<h1>$Apache::lonhomework::name</h1>";
  } elsif ($target eq 'edit') {
    $result=&Apache::edit::tag_start($target,$token);
    $result.='</td></tr>';
    $result.=&Apache::edit::end_table();
  }
  return $result;
}

sub end_displaytitle {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval)=@_;
  my @result;
  if ($target eq 'edit') { $result[1]='no'; }
  return @result;
}

1;
__END__
