# The LearningOnline Network with CAPA
# mutliple choice style responses
#
# $Id: radiobuttonresponse.pm,v 1.41 2002/05/03 20:13:14 albertel Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
# 2/21 Guy

package Apache::radiobuttonresponse;
use strict;

BEGIN {
  &Apache::lonxml::register('Apache::radiobuttonresponse',('radiobuttonresponse'));
}

sub start_radiobuttonresponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  my $result;
  #when in a radiobutton response use these
  &Apache::lonxml::register('Apache::radiobuttonresponse',('foilgroup','foil','conceptgroup'));
  push (@Apache::lonxml::namespace,'radiobuttonresponse');
  my $id = &Apache::response::start_response($parstack,$safeeval);
  if ($target eq 'meta') {
    $result=&Apache::response::meta_package_write('radiobuttonresponse');
  } elsif ($target eq 'edit' ) {
    $result.=&Apache::edit::start_table($token).
	'<tr><td>'.&Apache::lonxml::description($token)."</td><td>Delete:".
	&Apache::edit::deletelist($target,$token)
	."</td><td>&nbsp".&Apache::edit::end_row()
        .&Apache::edit::start_spanning_row();

    $result.=&Apache::edit::text_arg('Max Number Of Shown Foils:','max',$token,'4').
	&Apache::edit::end_row().&Apache::edit::start_spanning_row()."\n";
  } elsif ($target eq 'modified') {
    my $constructtag=&Apache::edit::get_new_args($token,$parstack,
						 $safeeval,'max');
    if ($constructtag) { $result = &Apache::edit::rebuild_tag($token); }
  } elsif ($target eq 'tex') {
      $result .= '\begin{enumerate}';
  }
  return $result;
}

sub end_radiobuttonresponse {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  my $result;
  if ($target eq 'edit') { $result=&Apache::edit::end_table(); }
  if ($target eq 'tex') { $result .= '\end{enumerate}'; }
  &Apache::response::end_response;
  pop @Apache::lonxml::namespace;
  &Apache::lonxml::deregister('Apache::radiobuttonresponse',('foilgroup','foil','conceptgroup'));
  return $result;
}

%Apache::response::foilgroup={};
sub start_foilgroup {
  %Apache::response::foilgroup={};
  $Apache::radiobuttonresponse::conceptgroup=0;
  &Apache::response::setrandomnumber();
  return '';
}

sub storesurvey {
  if ( !defined($ENV{'form.submitted'})) { return ''; }
  my $response = $ENV{'form.HWVAL'.$Apache::inputtags::response['-1']};
  &Apache::lonxml::debug("Here I am!:$response:");
  if ( $response !~ /[0-9]+/) { return ''; }
  my $id = $Apache::inputtags::response['-1'];
  my @whichfoils=@{ $Apache::response::foilgroup{'names'} };
  my %responsehash;
  $responsehash{$whichfoils[$response]}=$response;
  $Apache::lonhomework::results{"resource.$Apache::inputtags::part.$id.submission"}=&Apache::lonnet::hash2str(%responsehash);
  $Apache::lonhomework::results{"resource.$Apache::inputtags::part.$id.awarddetail"}='SUBMITTED';
  &Apache::lonxml::debug("submitted a $response<br />\n");
  return '';
}

sub grade_response {
  my ($max,$answer)=@_;
  if (!defined($ENV{'form.submitted'})) { return; }
  my $response = $ENV{'form.HWVAL'.$Apache::inputtags::response['-1']};
  if ( $response !~ /[0-9]+/) { return; }
  my $part=$Apache::inputtags::part;
  my $id = $Apache::inputtags::response['-1'];
  my @whichfoils=&whichfoils($max,$answer);
  my %responsehash;
  $responsehash{$whichfoils[$response]}=$response;
  my $responsestr=&Apache::lonnet::hash2str(%responsehash);
  my %previous=&Apache::response::check_for_previous($responsestr,
						     $part,$id);
  $Apache::lonhomework::results{"resource.$part.$id.submission"}=
    $responsestr;
  &Apache::lonxml::debug("submitted a $response<br />\n");
  my $ad;
  if ($response == $answer) {
    $ad='EXACT_ANS';
  } else {
    $ad='INCORRECT';
  }
  $Apache::lonhomework::results{"resource.$part.$id.awarddetail"}=$ad;
  &Apache::response::handle_previous(\%previous,$ad);
}

sub end_foilgroup {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;

  my $result;
  if ($target eq 'grade' || $target eq 'web' || $target eq 'answer' || $target eq 'tex') {
    my $style = $Apache::lonhomework::type;
    if ( $style eq 'survey' ) {
      if ($target eq 'web' || $target eq 'answer' || $target eq 'tex') {
	$result=&displayallfoils();
      } elsif ( $target eq 'grade' ) {
	$result=&storesurvey();
      }
    } else {
      my $name;
      my ($truecnt,$falsecnt,$max) = &getfoilcounts($parstack,$safeeval);
      my $count=0;
      # we will add in 1 of the true statements
      if (($falsecnt+1)>$max) { $count=$max } else { $count=$falsecnt+1; }
      my $answer = int(rand ($count));
      &Apache::lonxml::debug("Answer is $answer, $count from $max, $falsecnt");
      if ($target eq 'web' || $target eq 'tex') {
	$result=&displayfoils($target,$max,$answer);
      } elsif ($target eq 'answer' ) {
	$result=&displayanswers($max,$answer);
      } elsif ( $target eq 'grade') {
	&grade_response($max,$answer);
      }
    }
  }
  return $result;
}

sub getfoilcounts {
  my ($parstack,$safeeval)=@_;
  my $max = &Apache::lonxml::get_param('max',$parstack,$safeeval,'-2');
  my @names;
  my $truecnt=0;
  my $falsecnt=0;
  my $name;
  if ( $Apache::response::foilgroup{'names'} ) {
    @names= @{ $Apache::response::foilgroup{'names'} };
  }
  foreach $name (@names) {
    if ($Apache::response::foilgroup{$name.'.value'} eq 'true') {
      $truecnt++;
    } elsif ($Apache::response::foilgroup{$name.'.value'} eq 'false') {
      $falsecnt++;
    }
  }
  return ($truecnt,$falsecnt,$max);
}

sub displayallfoils {
  my $result;
  &Apache::lonxml::debug("survey style display");
  my @names = @{ $Apache::response::foilgroup{'names'} };
  my $temp=0;
  my $id=$Apache::inputtags::response['-1'];
  my $part=$Apache::inputtags::part;
  my $lastresponse=$Apache::lonhomework::history{"resource.$part.$id.submission"};
  my %lastresponse=&Apache::lonnet::str2hash($lastresponse);
  &Apache::lonhomework::showhash(%lastresponse);
  foreach my $name (@names) {
    if ($Apache::response::foilgroup{$name.'.value'} ne 'unused') {
      $result.="<br /><input type=\"radio\" name=\"HWVAL$Apache::inputtags::response['-1']\" value=\"$temp\" ";
      if (defined($lastresponse{$name})) { $result .= 'checked="on"'; }
      $result .= '>'.$Apache::response::foilgroup{$name.'.text'}."</input>\n";
      $temp++;
    }
  }
  return $result;
}

sub whichfoils {
  my ($max,$answer)=@_;

  my @truelist;
  my @falselist;
  my @whichfalse =();

  my @names;
  if ( $Apache::response::foilgroup{'names'} ) {
    @names= @{ $Apache::response::foilgroup{'names'} };
  }
  if (&Apache::response::showallfoils()) {
    @whichfalse=@names;
  } else {
    foreach my $name (@names) {
      #result.="<br /><b>$name</b> is <i> $Apache::response::foilgroup{$name.'.value'} </i>";
      if ($Apache::response::foilgroup{$name.'.value'} eq 'true') {
	push (@truelist,$name);
      } elsif ($Apache::response::foilgroup{$name.'.value'} eq 'false') {
	push (@falselist,$name);
      } elsif ($Apache::response::foilgroup{$name.'.value'} eq 'unused') {
      } else {
	&Apache::lonxml::error(&HTML::Entites::encode("No valid value assigned ($Apache::response::foilgroup{$name.'.value'}) for foil $name in <foilgroup>"));
      }
    }
    my $whichtrue = int(rand($#truelist+1));
    &Apache::lonxml::debug("Max is $max, From $#truelist elms, picking $whichtrue");
    while ((($#whichfalse+1) < $max-1) && ($#falselist > -1)) {
      &Apache::lonxml::debug("Have $#whichfalse max is $max");
      my $afalse=int(rand($#falselist+1));
      &Apache::lonxml::debug("From $#falselist elms, picking $afalse");
      $afalse=splice(@falselist,$afalse,1);
      &Apache::lonxml::debug("Picked $afalse");
      push (@whichfalse,$afalse);
    }
    splice(@whichfalse,$answer,0,$truelist[$whichtrue]);
    &Apache::lonxml::debug("the true statement is $answer");
  }
  return @whichfalse;
}

sub displayfoils {
  my ($target,$max,$answer)=@_;
  my $result;

  my @whichfoils=&whichfoils($max,$answer);
  if ($Apache::lonhomework::history{"resource.$Apache::inputtags::part.solved"} =~ /^correct/ ) {
    foreach my $name (@whichfoils) {
      if ($target ne 'tex') {
	  $result.="<br />";
      }
      if ($Apache::response::foilgroup{$name.'.value'} eq 'true') { 
	$result.='Correct';
      } else {
	$result.='Incorrect';
      }
      $result.=":".$Apache::response::foilgroup{$name.'.text'}."</input>\n";
    }
  } else {
    my $temp=0;
    my $id=$Apache::inputtags::response['-1'];
    my $part=$Apache::inputtags::part;
    my $lastresponse=$Apache::lonhomework::history{"resource.$part.$id.submission"};
    my %lastresponse=&Apache::lonnet::str2hash($lastresponse);
    foreach my $name (@whichfoils) {
      if ($target ne 'tex') {
	  $result.="<br /><input type=\"radio\" name=\"HWVAL$Apache::inputtags::response['-1']\" value=\"$temp\" ";
	  if (defined($lastresponse{$name})) { $result .= 'checked="on"'; }
	  $result .= '>'.$Apache::response::foilgroup{$name.'.text'}."</input>\n";
      } else {
	  $result .= $Apache::response::foilgroup{$name.'.text'};
      }
      $temp++;
    }
  }
  if ($target ne 'tex') { $result.="<br />"; }
  return $result;
}

sub displayanswers {
  my ($max,$answer)=@_;
  my @whichopt = &whichfoils($max,$answer);
  my $result=&Apache::response::answer_header('radiobuttonresponse');
  foreach my $name (@whichopt) {
    $result.=&Apache::response::answer_part('radiobuttonresponse',
		     $Apache::response::foilgroup{$name.'.value'})
  }
  $result.=&Apache::response::answer_footer('radiobuttonresponse');
  return $result;
}

sub start_conceptgroup {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  $Apache::radiobuttonresponse::conceptgroup=1;
  %Apache::response::conceptgroup={};
  my $result;
  if ($target eq 'edit') {
    $result.=&Apache::edit::tag_start($target,$token);
    $result.=&Apache::edit::text_arg('Concept:','concept',$token,'50').
	&Apache::edit::end_row().&Apache::edit::start_spanning_row();
  } elsif ($target eq 'modified') {
    my $constructtag=&Apache::edit::get_new_args($token,$parstack,
						 $safeeval,'concept');
    if ($constructtag) { $result = &Apache::edit::rebuild_tag($token); }
  }
  return $result;
}

sub end_conceptgroup {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  $Apache::radiobuttonresponse::conceptgroup=0;
  my $result;
  if ($target eq 'web' || $target eq 'grade' || $target eq 'answer'  || $target eq 'tex') {
    if (defined(@{ $Apache::response::conceptgroup{'names'} })) {
      my @names = @{ $Apache::response::conceptgroup{'names'} };
      my $pick=int(rand($#names+1));
      my $name=$names[$pick];
      push @{ $Apache::response::foilgroup{'names'} }, $name;
      $Apache::response::foilgroup{"$name.text"} =  $Apache::response::conceptgroup{"$name.text"};
      $Apache::response::foilgroup{"$name.value"} = $Apache::response::conceptgroup{"$name.value"};
      my $concept = &Apache::lonxml::get_param('concept',$parstack,$safeeval);
      $Apache::response::foilgroup{"$name.concept"} = $concept;
      &Apache::lonxml::debug("Selecting $name in $concept");
    }
  } elsif ($target eq 'edit') {
    $result=&Apache::edit::end_table();
  }
  return $result;
}

sub insert_conceptgroup {
  my $result="\n\t\t<conceptgroup concept=\"\">".&insert_foil()."\n\t\t</conceptgroup>\n";
  return $result;
}

sub start_foil {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  my $result='';
  if ($target eq 'web' || $target eq 'tex') {
    &Apache::lonxml::startredirection;
    if ($target eq 'tex') {
	$result .= '\item ';
    }
  } elsif ($target eq 'edit') {
    $result=&Apache::edit::tag_start($target,$token);
    $result.=&Apache::edit::text_arg('Name:','name',$token);
    $result.=&Apache::edit::select_arg('Correct Option:','value',
				       ['unused','true','false'],$token);
    $result.=&Apache::edit::end_row().&Apache::edit::start_spanning_row();
  } elsif ($target eq 'modified') {
     my $constructtag=&Apache::edit::get_new_args($token,$parstack,$safeeval,
						  'value','name');
    if ($constructtag) { $result = &Apache::edit::rebuild_tag($token); }
  } 
  return $result;
}

sub end_foil {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
  my $text='';
  if ($target eq 'web' || $target eq 'tex') { $text=&Apache::lonxml::endredirection; }
  if ($target eq 'web' || $target eq 'grade' || $target eq 'answer'  || $target eq 'tex') {
    my $value = &Apache::lonxml::get_param('value',$parstack,$safeeval);
    if ($value ne 'unused') {
      my $name = &Apache::lonxml::get_param('name',$parstack,$safeeval);
      if (!$name) { $name=$Apache::lonxml::curdepth; }
      if ( $Apache::radiobuttonresponse::conceptgroup
	   && !&Apache::response::showallfoils() ) {
	push @{ $Apache::response::conceptgroup{'names'} }, $name;
	$Apache::response::conceptgroup{"$name.value"} = $value;
	$Apache::response::conceptgroup{"$name.text"} = $text;	
      } else {
	push @{ $Apache::response::foilgroup{'names'} }, $name;
	$Apache::response::foilgroup{"$name.value"} = $value;
	$Apache::response::foilgroup{"$name.text"} = $text;
      }
    }
  }
  return '';
}

sub insert_foil {
  return '
<foil name="" value="unused">
<startouttext />
<endouttext />
</foil>';
}
1;
__END__
 
