# The LearningOnline Network
# Create a course
#
# $Id: loncreatecourse.pm,v 1.9 2002/04/23 21:05:45 matthew Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
# (My Desk
#
# (Internal Server Error Handler
#
# (Login Screen
# 5/21/99,5/22,5/25,5/26,5/31,6/2,6/10,7/12,7/14,
# 1/14/00,5/29,5/30,6/1,6/29,7/1,11/9 Gerd Kortemeyer)
#
# 3/1/1 Gerd Kortemeyer)
#
# 3/1 Gerd Kortemeyer)
#
# 2/14,2/16,2/17,7/6 Gerd Kortemeyer
#
package Apache::loncreatecourse;

use strict;
use Apache::Constants qw(:common :http);
use Apache::lonnet;

# ===================================================== Phase one: fill-in form

sub phase_one {
    my $r=shift;
    my $defdom=$ENV{'user.domain'};
    my $domform = &Apache::loncommon::select_dom_form($defdom,'ccdomain');
    $r->print(<<ENDDOCUMENT);
<html>
<script language="JavaScript" type="text/javascript">
var editbrowser = null;
function openbrowser(formname,elementname) {
    var url = '/res/?';
    if (editbrowser == null) {
        url += 'launch=1&';
    }
    url += 'catalogmode=interactive&';
    url += 'mode=edit&';
    url += 'form=' + formname + '&';
    url += 'element=' + elementname + '&';
    url += 'only=sequence' + '';
    var title = 'Browser';
    var options = 'scrollbars=1,resizable=1,menubar=0';
    options += ',width=700,height=600';
    editbrowser = open(url,title,options,'1');
    editbrowser.focus();
}
</script>
<head>
<title>The LearningOnline Network with CAPA</title>
</head>
<body bgcolor="#FFFFFF">
<img align="right" src="/adm/lonIcons/lonlogos.gif">
<h1>Create a new Course</h1>
<form action="/adm/createcourse" method="post" name="ccrs">
<h3>Course Title</h3>
<input type="text" size="50" name="title">
<h3>Top-level Map</h3>
<input type="text" size="50" name="topmap">
<a href="javascript:openbrowser('ccrs','topmap')">Browse</a>
<h3>Course ID/Number (optional)</h3>
<input type="text" size="30" name="crsid">
<h3>Course Coordinator</h3>
Username: <input type="text" size="15" name="ccuname" /><br>
Domain:   $domform
<input type="hidden" name="phase" value="two" /><p>
<input type="submit" value="Open Course">
</form>
</body>
</html>
ENDDOCUMENT
}

# ====================================================== Phase two: make course

sub phase_two {
    my $r=shift;
    my $topurl='/res/'.&Apache::lonnet::declutter($ENV{'form.topmap'});
    my $ccuname=$ENV{'form.ccuname'};
    my $ccdomain=$ENV{'form.ccdomain'};
    $ccuname=~s/\W//g;
    $ccdomain=~s/\W//g;
    my $cdescr=$ENV{'form.title'};
    my $curl=$ENV{'form.topmap'};
    $r->print(<<ENDENHEAD);
<html>
<head>
<title>The LearningOnline Network with CAPA</title>
</head>
<body bgcolor="#FFFFFF">
<img align=right src=/adm/lonIcons/lonlogos.gif>
<h1>Create a new Course</h1>
ENDENHEAD
#
# Verify data
#
    if (&Apache::lonnet::homeserver($ccuname,$ccdomain) eq 'no_host') {
        $r->print('No such user '.$ccuname.' at '.$ccdomain.'</body></html>');
	return;
    }

#
# Open course
#
    my $courseid=&Apache::lonnet::createcourse($ENV{'user.domain'},
                                               $cdescr,$curl);

    $r->print('New LON-CAPA Course ID: '.$courseid.'<br>');
#
# Set optional courseid
#
    my ($crsudom,$crsunum)=($courseid=~/^\/(\w+)\/(\w+)$/);
    my $crsuhome=&Apache::lonnet::homeserver($crsunum,$crsudom);
    $r->print('Created on: '.$crsuhome.'<br>');
    if ($ENV{'form.crsid'}) {
       $r->print('Setting optional Course ID/Number: '.                 
           &Apache::lonnet::reply('put:'.$crsudom.':'.
                                  $crsunum.':environment:courseid='.
                                  &Apache::lonnet::escape($ENV{'form.crsid'}),
                                  $crsuhome).'<br>');
    }
#
# Make current user course adminstrator
#
    $r->print('Assigning role of course coordinator to self: '.
    &Apache::lonnet::assignrole(
     $ENV{'user.domain'},$ENV{'user.name'},$courseid,'cc').'<br>');
#
# Make additional user course administrator
#
    $r->print('Assigning role of course coordinator to '.
               $ccuname.' at '.$ccdomain.': '.
    &Apache::lonnet::assignrole($ccdomain,$ccuname,$courseid,'cc').'<p>');
    $r->print('Roles will be active at next login.</body></html>');
}

# ===================================================================== Handler
sub handler {
    my $r = shift;

    if ($r->header_only) {
       $r->content_type('text/html');
       $r->send_http_header;
       return OK;
    }

    if (&Apache::lonnet::allowed('ccc',$ENV{'user.domain'})) {
       $r->content_type('text/html');
       $r->send_http_header;

       if ($ENV{'form.phase'} eq 'two') {
           &phase_two($r);
       } else {
	   &phase_one($r);
       }
   } else {
      $ENV{'user.error.msg'}=
        "/adm/createcourse:ccc:0:0:Cannot create courses";
      return HTTP_NOT_ACCEPTABLE; 
   }
   return OK;
} 

1;
__END__
