
# The LearningOnline Network with CAPA
# Tags Default Definition Module 
#
# $Id: londefdef.pm,v 1.67 2002/07/01 19:58:25 sakharuk Exp $
# 
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
# Copyright for TtHfunc and TtMfunc by Ian Hutchinson. 
# TtHfunc and TtMfunc (the "Code") may be compiled and linked into 
# binary executable programs or libraries distributed by the 
# Michigan State University (the "Licensee"), but any binaries so 
# distributed are hereby licensed only for use in the context
# of a program or computational system for which the Licensee is the 
# primary author or distributor, and which performs substantial 
# additional tasks beyond the translation of (La)TeX into HTML.
# The C source of the Code may not be distributed by the Licensee
# to any other parties under any circumstances.
#
#
# last modified 06/26/00 by Alexander Sakharuk
# 11/6,11/30,02/01/01,5/4 Gerd Kortemeyer
# 01/18 Alex Sakharuk

package Apache::londefdef; 

use Apache::lonnet;
use strict;
use Apache::lonxml;
use Apache::File();

BEGIN {

    &Apache::lonxml::register('Apache::londefdef',('m','html','head','map','select','option','input','textarea','form','meta','title','body','center','b','strong','dt','h1','h2','h3','h4','h5','h6','cite','i','address','dd','dl','dir','ol','ul','menu','dfn','kbd','tt','code','em','q','p','br','big','small','basefont','font','s','sub','strike','sup','hr','a','li','u','output','param','applet','img','embed','allow','frameset','pre','insert','externallink','table','tr','th','td','blankspace','bubble','bubbles','bubbleline'));

}

#======================= TAG SUBROUTINES =====================
#-- <output>
sub start_output {
  my ($target) = @_;
  if ($target eq 'meta') { $Apache::lonxml::metamode--; }
  return '';
}
sub end_output {
  my ($target) = @_;
  if ($target eq 'meta') { $Apache::lonxml::metamode++; }
  return '';
}
#-- <m> tag
sub start_m {
  my ($target,$token,$tagstack,$parstack,$parser,$safeeval) = @_;
  my $currentstring = '';
  if ($target eq 'web') {
    $Apache::lonxml::prevent_entity_encode++;
    my $inside = &Apache::lonxml::get_all_text("/m",$$parser[-1]);
    $inside ='\\documentstyle{article}'.$inside;
    &Apache::lonxml::debug("M is starting with:$inside:");
    my $eval=&Apache::lonxml::get_param('eval',$parstack,$safeeval);
    if ($eval eq 'on') {
      $inside=&Apache::run::evaluate($inside,$safeeval,$$parstack[-1]);
      #&Apache::lonxml::debug("M is evaulated to:$inside:");
    }
    $currentstring = &Apache::lontexconvert::converted(\$inside);
    if ($Apache::lontexconvert::errorstring) {
      &Apache::lonxml::warning("tth error: ".
			       $Apache::lontexconvert::errorstring);
      $Apache::lontexconvert::errorstring='';
    }
    #&Apache::lonxml::debug("M is ends with:$currentstring:");
  } elsif ($target eq 'tex') {
    $currentstring = "";
  }
  return $currentstring;
}
sub end_m {
  my ($target,$token) = @_;
  my $currentstring = '';
  if ($target eq 'web') {
    $Apache::lonxml::prevent_entity_encode--;
  } elsif ($target eq 'tex') {
    $currentstring = "";
  } elsif ($target eq 'meta') {
  }
  return $currentstring;
}
#-- <html> tag    
      sub start_html {
	    my ($target,$token) = @_;
            my $currentstring = '';
	    if ($ENV{'browser.mathml'}) {
	      &tth::ttminit();
	    } else {
	      &tth::tthinit();
	    }
            if ($target eq 'web') {
              $currentstring = &Apache::lonxml::xmlbegin().
                               &Apache::lonxml::fontsettings();     
	    } elsif ($target eq 'tex') {
	      @Apache::londefdef::table = ();
	      $currentstring .= '\documentclass[letterpaper]{article}
                                 \newcommand{\keephidden}[1]{}           
                                 \usepackage[dvips]{graphicx}
                                 \usepackage{epsfig}\usepackage{calc}';
	    }
	   return $currentstring;
	}
        sub end_html {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
		$currentstring = &Apache::lonxml::xmlend();
	    }
	   return $currentstring;
	}
#-- <head> tag
      sub start_head {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_head {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = &Apache::lonxml::registerurl(undef,$target).
                               $token->[2];    
            } 
	   return $currentstring;
	}
#-- <map> tag
      sub start_map {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_map {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#-- <select> tag
      sub start_select {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_select {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#-- <option> tag
      sub start_option {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_option {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#-- <input> tag
      sub start_input {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_input {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#-- <textarea> tag
      sub start_textarea {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_textarea {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#-- <form> tag
      sub start_form {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_form {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#-- <title> tag
      sub start_title {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring .= '\keephidden{' 
	    }
            if ($target eq 'meta') {
		$currentstring='<title>';
                &start_output();
            }
	   return $currentstring;
	}
        sub end_title {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } elsif ($target eq 'tex') {
              $currentstring .= '}';
	    }  
            if ($target eq 'meta') {
               &end_output();
               $currentstring='</title>';
            } 
	   return $currentstring;
	}
#-- <meta> tag
      sub start_meta {
	    my ($target,$token,$tagstack,$parstack,$parser) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	      my $args='';
	      if ( $#$parstack > -1 ) { $args=$$parstack[$#$parstack]; }
	      if ($args eq '') {
		&Apache::lonxml::get_all_text("/meta",$$parser[$#$parser]);
	      } else {
		$currentstring = $token->[4];
	      }
	    }
            if ($target eq 'meta') {
		unless ($token->[2]->{'http-equiv'}) {
		    my $name=$token->[2]->{'name'};
                    $name=~tr/A-Z/a-z/;
                    $name=~s/\s/\_/g;
                    if ($name) {
                       $currentstring='<'.$name.'>'.
                                         $token->[2]->{'content'}.
			              '</'.$name.'>';
		    }
                }
	    }
	   return $currentstring;
	}
      sub end_meta {
	my ($target,$token,$tagstack,$parstack,$parser) = @_;
	my $currentstring = '';
	if ($target eq 'web') {
	  my $args='';
	  if ( $#$parstack > -1 ) { $args=$$parstack[$#$parstack]; }
	  if ($args ne '') {
	    $currentstring = $token->[4];
	  }
	} 
	return $currentstring;
      }
#-- <body> tag
        sub start_body {
            my ($target,$token,$tagstack,$parstack,$parser,$safeeval) = @_;
#	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	      if (!$Apache::lonxml::registered) {
		$currentstring.='<head>'.
		    &Apache::lonxml::registerurl(undef,$target).'</head>';
	      }
	      my $onLoad='';
	      foreach my $key (keys(%{$token->[2]})) {
		if ($key =~ /^onload$/i) {
		  $onLoad.=$token->[2]->{$key}.';';
		  delete($token->[2]->{$key});
		}
	      }
	      $token->[2]->{'onLoad'}=&Apache::lonxml::loadevents().
		                       ';'.$onLoad;
	      my $onUnload='';
	      foreach my $key (keys(%{$token->[2]})) {
		if ($key =~ /^onunload$/i) {
		  $onUnload.=$token->[2]->{$key}.';';
		  delete($token->[2]->{$key});
		}
	      }
	      $token->[2]->{'onUnload'}=&Apache::lonxml::unloadevents().
		                         ';'.$onUnload;

	      $currentstring .= '<'.$token->[1];
	      foreach (keys %{$token->[2]}) {
	      	$currentstring.=' '.$_.'="'.$token->[2]->{$_}.'"';
	      }
	      $currentstring.='>';
	      if ($ENV{'request.state'} ne 'published') {
		$currentstring.=(<<EDITBUTTON);
		<form method="post">
		<input type="submit" name="editmode" value="Edit" />
		</form>
EDITBUTTON
	      }
       	    } elsif ($target eq 'tex') {
              $currentstring = '\begin{document}';  
	    } 
	   return $currentstring;
	}
        sub end_body {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = '\end{document}';  
	    } 
	   return $currentstring;
	}
#-- <center> tag
        sub start_center {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = '\begin{center}';  
	    }  elsif ($target eq 'latexsource') {
              $currentstring = '\begin{center}';  
	    } 
	   return $currentstring;
	}
        sub end_center {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = '\end{center}';  
	    }  elsif ($target eq 'latexsource') {
              $currentstring = '\end{center}';  
	    } 
	   return $currentstring;
	}
#-- <b> tag
        sub start_b {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = '\textbf{';  
	    }  elsif ($target eq 'latexsource') {
              $currentstring = '\textbf{';  
	    } 
	   return $currentstring;
	}
        sub end_b {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = '}';  

	    } elsif ($target eq 'latexsource') {
              $currentstring = '}';  
	    } 
	   return $currentstring;
	}
#-- <strong> tag
        sub start_strong {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = '\textbf{';  
	    } elsif ($target eq 'latexsource') {
              $currentstring = '\textbf{';  
	    } 
	   return $currentstring;
	}
        sub end_strong {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {

              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = '}';  
	    }  elsif ($target eq 'latexsource') {
              $currentstring = '}';  
	    } 
	   return $currentstring;
	}
#-- <h1> tag
        sub start_h1 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\large{\textbf{';
	    } elsif ($target eq 'meta') {
		$currentstring='<subject>';
                &start_output();
            }
           return $currentstring;
	}
        sub end_h1 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= '}}';
	    } elsif ($target eq 'meta') {
                &end_output();
		$currentstring='</subject>';
            } 
           return $currentstring;
	}
#-- <h2> tag
        sub start_h2 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\large{\textbf{';
	    } 
           return $currentstring;
	}
        sub end_h2 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= '}}';
	    } 
           return $currentstring;
	}
#-- <h3> tag
        sub start_h3 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\large{\textbf{';
	    } 
           return $currentstring;
	}
        sub end_h3 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= '}}';
	    } 
           return $currentstring;
	}
#-- <h4> tag
        sub start_h4 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\large{\textbf{';
	    } 
           return $currentstring;
	}
        sub end_h4 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= '}}';
	    } 
           return $currentstring;
	}
#-- <h5> tag
        sub start_h5 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\large{\textbf{';
	    } 
           return $currentstring;
	}
        sub end_h5 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= '}}';
	    } 
           return $currentstring;
	}
#-- <h6> tag
        sub start_h6 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\large{\textbf{';
	    } 
           return $currentstring;
	}
        sub end_h6 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= '}}';
	    } 
           return $currentstring;
	}
#--- <cite> tag
        sub start_cite {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\textit{";
	    }  elsif ($target eq 'latexsource') {
		$currentstring .= "\\textit{";
	    } 
           return $currentstring;
	}
        sub end_cite {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    }  elsif ($target eq 'latexsource') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#-- <i> tag
        sub start_i {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\textit{';
	    }  elsif ($target eq 'latexsource') {
		$currentstring .= '\textit{';
	    } 
           return $currentstring;
	}
        sub end_i {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= '}';
	    } elsif ($target eq 'latexsource') {
		$currentstring .= '}';
	    } 
           return $currentstring;
	}
#-- <address> tag
        sub start_address {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\textit{";
	    } elsif ($target eq 'latexsource') {
		$currentstring .= "\\textit{";
	    } 
           return $currentstring;
	}
        sub end_address {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } elsif ($target eq 'latexsource') {
		$currentstring .= "}";
	    }
           return $currentstring;
	}
#-- <dfn> tag
        sub start_dfn {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\textit{";
	    } elsif ($target eq 'latexsource') {
		$currentstring .= "\\textit{";
	    } 
           return $currentstring;
	}
        sub end_dfn {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } elsif ($target eq 'latexsource') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#-- <tt> tag
        sub start_tt {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\texttt{';
	    } elsif ($target eq 'latexsource') {
		$currentstring .= '\texttt{';
	    } 
           return $currentstring;
	}
        sub end_tt {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= '}';
	    } elsif ($target eq 'latexsource') {
		$currentstring .= '}';
	    }
           return $currentstring;
	}
#-- <kbd> tag
        sub start_kbd {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\texttt";
	    } elsif ($target eq 'latexsource') {
		$currentstring .= "\\texttt{";
	    } 
           return $currentstring;
	}
        sub end_kbd {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } elsif ($target eq 'latexsource') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#-- <code> tag
        sub start_code {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\texttt{';
	    } 
           return $currentstring;
	}
        sub end_code {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= '}';
	    } 
           return $currentstring;
	}
#-- <em> tag
        sub start_em {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\emph{';
	    } elsif ($target eq 'latexsource') {
		$currentstring .= '\emph{';
	    } 
           return $currentstring;
	}
        sub end_em {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= '}';
	    } elsif ($target eq 'latexsource') {
		$currentstring .= '}';
	    }  
           return $currentstring;
	}
#-- <q> tag
        sub start_q {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\emph{";
	    }  elsif ($target eq 'latexsource') {
		$currentstring .= "\\emph{";
	    }
           return $currentstring;
	}
        sub end_q {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } elsif ($target eq 'latexsource') {
		$currentstring .= "}";
	    }  
           return $currentstring;
	}
#-- <p> tag
        sub start_p {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '{\par ';
	    } elsif ($target eq 'latexsource') {
		$currentstring .= '{\par ';
	    } 
           return $currentstring;
	}
        sub end_p {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= '}';
            } elsif ($target eq 'latexsource') {
	        $currentstring .= '}';
            }
           return $currentstring;
	}
#-- <br> tag
        sub start_br {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\vskip 0 mm';
	    } elsif ($target eq 'latexsource') {
		$currentstring .= '\\';
	    } 
           return $currentstring;
	}
        sub end_br {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    }
           return $currentstring;
	}
#-- <big> tag
        sub start_big {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\large{';
	    } elsif ($target eq 'latexsource') {
		$currentstring .= '{\Large ';
	    }  
           return $currentstring;
	}
        sub end_big {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= '}';
            } elsif ($target eq 'latexsource') {
	        $currentstring .= '}';
            }
           return $currentstring;
	}
#-- <small> tag
        sub start_small {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '{\footnotesize ';
	    } elsif ($target eq 'latexsource') {
		$currentstring .= '{\footnotesize ';
	    } 
           return $currentstring;
	}
        sub end_small {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= '}';
            } elsif ($target eq 'latexsource') {
	        $currentstring .= '}';
            }
           return $currentstring;
	}
#-- <basefont> tag
      sub start_basefont {
	my ($target,$token) = @_;
	my $currentstring = '';
	if ($target eq 'web') {
	  $currentstring = $token->[4];     
	} 
	return $currentstring;
      }
      sub end_basefont {
	my ($target,$token) = @_;
	my $currentstring = '';
	if ($target eq 'web') {
	  $currentstring = $token->[4];     
	} 
	return $currentstring;
      }
#-- <font> tag
         sub start_font {
	    my ($target,$token,$tagstack,$parstack,$parser,$safeeval)=@_;
            my $currentstring = '';
            if ($target eq 'web') {
	      my $face=&Apache::lonxml::get_param('face',$parstack,$safeeval);
	      if ($face=~/symbol/i) {$Apache::lonxml::prevent_entity_encode++;}
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_font {
	    my ($target,$token,$tagstack,$parstack,$parser,$safeeval)=@_;
            my $currentstring = '';
            if ($target eq 'web') {
	      my $face=&Apache::lonxml::get_param('face',$parstack,$safeeval);
	      if ($face=~/symbol/i) {$Apache::lonxml::prevent_entity_encode--;}
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	} 
#-- <strike> tag
        sub start_strike {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{\\underline ";
	    } 
           return $currentstring;
	}
        sub end_strike {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }";
            }
           return $currentstring;
	}
#-- <s> tag
        sub start_s {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{\\underline ";
	    } 
           return $currentstring;
	}
        sub end_s {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }";
            }
           return $currentstring;
	}
#-- <sub> tag
        sub start_sub {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\$_{ ";
	    } 
           return $currentstring;
	}
        sub end_sub {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }\$";
            }
           return $currentstring;
	}
#-- <sup> tag
        sub start_sup {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\$^{ ";
	    } 
           return $currentstring;
	}
        sub end_sup {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }\$";
            }
           return $currentstring;
	}
#-- <hr> tag
        sub start_hr {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\hline ";
	    } 
           return $currentstring;
	}
        sub end_hr {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	    } 
           return $currentstring;
	}
#-- <a> tag
        sub start_a {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
	    }
           return $currentstring;
	}
        sub end_a {
	    my ($target,$token,$tagstack,$stackref) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
                my  $tempor_var = $stackref->[$#$stackref];
		if (index($tempor_var,'name') != -1 ) {
		    $tempor_var =~ s/name=([^,]*),/$1/g;
#	        $currentstring .= " \\label{$tempor_var}";
	        } elsif (index($tempor_var,'href') != -1 ) {
		    $tempor_var =~ s/href=([^,]*),/$1/g;
	        $currentstring .= " \\ref{$tempor_var}";
	        }
            }
           return $currentstring;
	}
#-- <li> tag
        sub start_li {
	    my ($target,$token,$tagstack,$stackref) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
                my  $tempor_var = $stackref->[$#$stackref];
                if (index($tempor_var,'circle') != -1 ) {
	          $currentstring .= " \\item[o] ";
	        } elsif (index($tempor_var,'square') != -1 ) {
	               $currentstring .= " \\item[$\Box$] ";
	        } elsif ($tempor_var ne '') { 
		       $_ = $tempor_var;
                       m/my\s*([^=]*)=/;
		       $currentstring .= " \\item[$1] ";
		} else {
		    $currentstring .= " \\item ";
	        }  
	    } 
	   return $currentstring;
	}
        sub end_li {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } 
	   return $currentstring;
	}
#-- <u> tag
        sub start_u {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{\\underline ";
	    } 
           return $currentstring;
	}
        sub end_u {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }";
            }
           return $currentstring;
	}
#-- <ul> tag
        sub start_ul {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = '\begin{itemize}';  
	    } 
	   return $currentstring;
	}
        sub end_ul {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = '\end{itemize}';  
	    } 
	   return $currentstring;
	}
#-- <menu> tag
        sub start_menu {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\begin{itemize} ";  
	    } 
	   return $currentstring;
	}
        sub end_menu {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\end{itemize}";  
	    } 
	   return $currentstring;
	}
#-- <dir> tag
        sub start_dir {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\begin{itemize} ";  
	    } 
	   return $currentstring;
	}
        sub end_dir {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\end{itemize}";  
	    } 
	   return $currentstring;
	}
#-- <ol> tag
        sub start_ol {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = '\begin{enumerate}';  
	    } 
	   return $currentstring;
	}
        sub end_ol {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = '\end{enumerate}';  
	    } 
	   return $currentstring;
	}
#-- <dl> tag
        sub start_dl {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = '\begin{description}';  
	    } 
	   return $currentstring;
	}
        sub end_dl {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = '\end{description}';  
	    } 
	   return $currentstring;
	}
#-- <dt> tag
        sub start_dt {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = '\item[';  
	    } 
	   return $currentstring;
	}
        sub end_dt {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } elsif ($target eq 'tex') {
              $currentstring = ']';  
	    } 
	   return $currentstring;
	}
#-- <dd> tag
        sub start_dd {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_dd {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#-- <table> tag
        sub start_table {
	    my ($target,$token,$tagstack,$parstack,$parser,$safeeval) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
		my $aa = {};
		push @Apache::londefdef::table, $aa; 
		$Apache::londefdef::table[-1]{'row_number'} = -1;
		$Apache::londefdef::table[-1]{'output'} = '\begin{tabular} ';
		my $border = &Apache::lonxml::get_param('border',$parstack,$safeeval);
		unless (defined $border) { $border = 0; }
		if ($border) { 
		    $Apache::londefdef::table[-1]{'hinc'} = '\hline '; 
		    $Apache::londefdef::table[-1]{'vinc'} = '&'; 
		    $Apache::londefdef::table[-1]{'vvinc'} = '|';
		} else {
		    $Apache::londefdef::table[-1]{'hinc'} = ''; 
		    $Apache::londefdef::table[-1]{'vinc'} = ''; 
		    $Apache::londefdef::table[-1]{'vvinc'} = '';
		}
	    } 
	   return $currentstring;
	}
        sub end_table {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
		my $inmemory = '';
		my $output = '';
		my $header_of_table = '{'.$Apache::londefdef::table[-1]{'vvinc'};
		my $in;
		for ($in=0;$in<=$Apache::londefdef::table[-1]{'counter_columns'};$in++) {
		    $header_of_table .= $Apache::londefdef::table[-1]{'columns'}[$in].$Apache::londefdef::table[-1]{'vvinc'};
		}
		$header_of_table .= '}';
		for ($in=0;$in<=$Apache::londefdef::table[-1]{'row_number'};$in++) {
		    $output .=  $Apache::londefdef::table[-1]{'rowdata'}[$in];
		    chop $output;
		    $output .= ' \\\\ ';
		}
		$Apache::londefdef::table[-1]{'output'} .= $header_of_table.$output.$Apache::londefdef::table[-1]{'hinc'}.'\end{tabular}';
		if ($#Apache::londefdef::table > 0) {
		    $inmemory = $Apache::londefdef::table[-1]{'output'};
		    pop @Apache::londefdef::table;
		    $Apache::londefdef::table[-1]{'rowdata'}[$Apache::londefdef::table[-1]{'row_number'}] .= $inmemory;
		} else {
		    $currentstring = $Apache::londefdef::table[-1]{'output'};
		    $currentstring =~ s/\\\\\s+\\\\/\\\\/g; 
		    pop @Apache::londefdef::table;
		}
	    }
	   return $currentstring;
	}
#-- <tr> tag
        sub start_tr {
	    my ($target,$token,$tagstack,$parstack,$parser,$safeeval) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
		$Apache::londefdef::table[-1]{'row_number'}++;
		my $alignchar = substr(&Apache::lonxml::get_param('align',$parstack,$safeeval),0,1);
		if ($alignchar ne '') {
		    push @ {$Apache::londefdef::table[-1]{'rows'} }, $alignchar;
		} else {
		    push @ {$Apache::londefdef::table[-1]{'rows'} }, 'c';
		}
		push ( @{ $Apache::londefdef::table[-1]{'rowdata'} }, $Apache::londefdef::table[-1]{'hinc'});
		$Apache::londefdef::table[-1]{'counter_columns'} = -1;

	    } 
	   return $currentstring;
	}        
        sub end_tr {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
		$currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
#		$currentstring .= ' START ROW '. $Apache::londefdef::table[-1]{'rowdata'}[$Apache::londefdef::table[-1]{'row_number'}].' END ROW ';
	    }
	   return $currentstring;
	}
#-- <td> tag
        sub start_td {
	    my ($target,$token,$tagstack,$parstack,$parser,$safeeval) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
		my $what_to_push = substr(&Apache::lonxml::get_param('align',$parstack,$safeeval),0,1);
		if ($what_to_push eq '') {
		    $what_to_push = substr($Apache::londefdef::table[-1]{'rows'}[0],0,1);;
		}
		    push @{ $Apache::londefdef::table[-1]{'columns'} }, $what_to_push;
		$Apache::londefdef::table[-1]{'counter_columns'}++;
		&Apache::lonxml::startredirection();
;
	    } 
	   return $currentstring;
	}        
        sub end_td {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
		$currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
		my $current_row = $Apache::londefdef::table[-1]{'row_number'};
		my $data=&Apache::lonxml::endredirection();
		@{ $Apache::londefdef::table[-1]{'rowdata'} }[$current_row] .= $data.' '.$Apache::londefdef::table[-1]{'vinc'};
	    }
	   return $currentstring;
	}
#-- <th> tag
        sub start_th {
	    my ($target,$token,$tagstack,$parstack,$parser,$safeeval) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
		my $what_to_push = substr(&Apache::lonxml::get_param('align',$parstack,$safeeval),0,1);
		if ($what_to_push eq '') {
		    $what_to_push = substr($Apache::londefdef::table[-1]{'rows'}[0],0,1);;
		}
		    push @{ $Apache::londefdef::table[-1]{'columns'} }, $what_to_push;
		$Apache::londefdef::table[-1]{'counter_columns'}++;
		&Apache::lonxml::startredirection();
;
	    } 
	   return $currentstring;
	}        
        sub end_th {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
		$currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
		my $current_row = $Apache::londefdef::table[-1]{'row_number'};
		my $data=&Apache::lonxml::endredirection();
		@{ $Apache::londefdef::table[-1]{'rowdata'} }[$current_row] .= '\bf{'.$data.'} '.$Apache::londefdef::table[-1]{'vinc'};
	    }
	   return $currentstring;
	}
#-- <img> tag
        sub start_img {
	    my ($target,$token,$tagstack,$parstack,$parser,$safeeval) = @_;
            $Apache::lonxml::extlinks[$#Apache::lonxml::extlinks+1]=
                                        $token->[2]->{'src'};
            my $currentstring = '';
	    my $width_param = '';

	    if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
	      my $TeXwidth = &Apache::lonxml::get_param('TeXwidth',$parstack,$safeeval); 
              my $TeXheight = &Apache::lonxml::get_param('TeXheight',$parstack,$safeeval); 
	      my $width = &Apache::lonxml::get_param('width',$parstack,$safeeval);
	      if ($TeXwidth ne '') { 
		  $width_param = $TeXwidth; 
	      } elsif ($TeXheight ne '') { 
		  $width_param = $TeXheight; 
	      } else {
		  if ($width ne '') {
		      $width_param = $width*.3;
		      if ($width_param <= 900) {
			  $width_param = '[width='.$width_param.'mm]';
		      } else {
			  $width_param = '[width= 9.0 cm]';
		      }
		  }
	      }
	      my $src = &Apache::lonxml::get_param('src',$parstack,$safeeval);
	      $src=&Apache::lonnet::filelocation($Apache::lonxml::pwd[-1],$src);
	      my $epssrc = $src;
	      $epssrc =~ s/(\.gif|\.jpg|\.GIF|\.JPG)$/\.eps/;
	      if (not -e $epssrc) {
		  my $localfile = $epssrc;
		  $localfile =~ s/.*(\/res)/$1/;	
		  my $file;
		  my $path;	
		  if ($localfile =~ m!(.*)/([^/]*)$!) {
		      $file = $2;
		      $path = $1.'/'; 
		  }	
		  my $signal_eps = 0;
		  my @content_directory = &Apache::lonnet::dirlist($path);
		  for (my $iy=0;$iy<=$#content_directory;$iy++) {
		      my @tempo_array = split(/&/,$content_directory[$iy]);
		      $content_directory[$iy] = $tempo_array[0];
		      if ($file eq $tempo_array[0]) {
			  $signal_eps = 1;
			  last;
		      }
		  }
		  if ($signal_eps) {
		      my $eps_file = &Apache::lonnet::getfile($localfile);
		  } else {
		      $localfile = $src;
		      $localfile =~ s/.*(\/res)/$1/;	
		      my $as = &Apache::lonnet::getfile($src);
		      
		  }
	      }
	      my $file;
	      my $path;	
              if ($src =~ m!(.*)/([^/]*)$!) {
		  $file = $2;
		  $path = $1.'/'; 
	      }
	      my $newsrc = $src;
	      $newsrc =~ s/(\.gif|\.jpg)$/\.eps/i;
		  $file=~s/(\.gif|\.jpg)$/\.eps/i;
	      if (-e $newsrc) {
		  if ($path) {
		      $currentstring .= '\noindent\graphicspath{{'.$path.'}}\fbox{\includegraphics'.$width_param.'{'.$file.'}}';
		  }
	      } else {
		  my $temp_file;
		  my $filename = "/home/httpd/prtspool/$ENV{'user.name'}_$ENV{'user.domain'}_printout.dat";
		  $temp_file = Apache::File->new('>>'.$filename); 
		  print $temp_file "$src\n";
		  $currentstring .= '\graphicspath{{/home/httpd/prtspool/}}\fbox{\includegraphics'.$width_param.'{'.$file.'}}';
	      }
	    }
	    return $currentstring;
	}
        sub end_img {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];
	    } elsif ($target eq 'tex') {
              $currentstring = '';
	    }
	   return $currentstring;
	}
#-- <applet> tag

        sub start_applet {
	    my ($target,$token) = @_;
              $Apache::lonxml::extlinks[$#Apache::lonxml::extlinks+1]=   
                                        $token->[2]->{'code'};
              $Apache::lonxml::extlinks[$#Apache::lonxml::extlinks+1]=
                                        $token->[2]->{'archive'};
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];
	    } elsif ($target eq 'tex') {
              $currentstring = " \\begin{figure} ";
	    } 
	   return $currentstring;
	}
sub end_applet {
    my ($target,$token) = @_;
    my $currentstring = '';
    if ($target eq 'web') {
	$currentstring = $token->[2];
    } elsif ($target eq 'tex') {
	$currentstring = " \\end{figure}";
    } 
    return $currentstring;
}

#-- <embed> tag

sub start_embed {    
    my ($target,$token) = @_;
    $Apache::lonxml::extlinks[$#Apache::lonxml::extlinks+1]=
	$token->[2]->{'src'};
    my $currentstring = '';
    if ($target eq 'web') {
	$currentstring = $token->[4];
    } elsif ($target eq 'tex') {
	$currentstring = " \\begin{figure} ";  
    } 
    return $currentstring;
}
        sub end_embed {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\end{figure}";  
	    } 
	   return $currentstring;
	}

#-- <param> tag

        sub start_param {
	    my ($target,$token) = @_;
	    if ($token->[2]->{'name'} eq 'cabbase') {
                      $Apache::lonxml::extlinks[$#Apache::lonxml::extlinks+1]=
					     $token->[2]->{'value'};
            }   
            $Apache::lonxml::extlinks[$#Apache::lonxml::extlinks+1]=   
                                        $token->[2]->{'src'};
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\begin{figure} ";  
	    } 
	   return $currentstring;
	}
        sub end_param {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\end{figure}";  
	    } 
	   return $currentstring;
	}

#-- <allow> tag

        sub start_allow {
	    my ($target,$token) = @_;

            $Apache::lonxml::extlinks[$#Apache::lonxml::extlinks+1]=   
                                        $token->[2]->{'src'};

	   return '';
	}
        sub end_allow {
	   return '';
	}
#-- Frames
	sub start_frameset {
	  my ($target,$token) = @_;
	  my $currentstring = '';
	  if ($target eq 'web') { 
	    if (!$Apache::lonxml::registered) {
	      $currentstring.='<head>'.
		  &Apache::lonxml::registerurl(undef,$target).'</head>';
	    }
	    $currentstring .= $token->[4];
	  }
	  return $currentstring;
	}
        sub end_frameset {
	  my ($target,$token) = @_;
	  my $currentstring = '';
	  if ($target eq 'web') {
	    $currentstring = $token->[2];
	  }
	  return $currentstring;
	}
#-- <pre>
	sub start_pre {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\begin{verbatim}';
	    } 
           return $currentstring;
	}
        sub end_pre {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= '\end{verbatim}';
	    }
           return $currentstring;
	}
#-- <insert>
	sub start_insert {
	    my ($target,$token,$tagstack,$parstack,$parser,$safeeval) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
		my $display = &Apache::lonxml::get_param('display',$parstack,$safeeval);
	       $currentstring .= '<b>'.$display.'</b>';;
	    }
           return $currentstring;
	}
        sub end_insert {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= '';
	    }
           return $currentstring;
	}
#-- <externallink>
	sub start_externallink {
	    my ($target,$token,$tagstack,$parstack,$parser,$safeeval) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
		my $display = &Apache::lonxml::get_param('display',$parstack,$safeeval);
	       $currentstring .= '<b>'.$display.'</b>';;
	    }
           return $currentstring;
	}
        sub end_externallink {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= '';
	    }
           return $currentstring;
	}
#-- <blankspace heigth="">
        sub start_blankspace {
	    my ($target,$token,$tagstack,$parstack,$parser,$safeeval) = @_;
            my $currentstring = '';
            if ($target eq 'tex') {
		my $howmuch = &Apache::lonxml::get_param('heigth',$parstack,$safeeval);
		$currentstring .= '\vskip '.$howmuch.' ';
	    }
           return $currentstring;
	}
        sub end_blankspace {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'tex') {
	       $currentstring .= '';
	    }
           return $currentstring;
	}

1;
__END__
